Subject: Re: bug#35610: Freshly installed IBus intput method is not listed as an input source

From: sirgazil <[email-masked]>
Date: Tue, 07 May 2019 10:24:08 -0500

---- On Mon, 06 May 2019 19:36:17 -0500 Chris Marusich <[email-masked]> wrote ----

 > ison <[email-masked]> writes: 
 >  
 > > I currently have ibus with anthy working, but I had this exact same problem at 
 > > first. I'm not 100% sure what I finally did to solve it, but I think it may have 
 > > been a missing environment variable. Here is what I have set: 
 > > export GTK_IM_MODULE_FILE="/run/current-system/profile/lib/gtk-3.0/3.0.0/immodules-gtk3.cache" 
 > > export GTK_IM_MODULE="xim" 
 > > export XMODIFIERS="@im=ibus" 
 > > export QT_IM_MODULE="xim" 
 > > 
 > > I'm thinking the $GTK_IM_MODULE_FILE variable is the missing ingredient. 
 > > However, while attempting to fix this I also installed the packages: 
 > > ibus, ibus-anthy, dbus, python-dbus, python2-dbus 
 > > 
 > > If you need these packages too to make it work then perhaps its worth 
 > > investigating if the anthy package is missing some dependencies. 
 >  
 > FWIW I have the following in my ~/.bash_profile.  If you search the 
 > email list archives for these environment variables, you'll find some 
 > relevant discussions: 

I found the discussion. The topic is "Typing on GuixSD in languages other than English" (https://lists.gnu.org/archive/html/help-guix/2016-04/msg00006.html). I participated, I'm Luis Felipe :)

 > --8<---------------cut here---------------start------------->8--- 
 > # Enable GTK+2 and GTK+3 programs to simultaneously use the right 
 > # immodules cache file.  This is a Guix-specific work-around. 
 > # See: https://lists.gnu.org/archive/html/guix-devel/2016-08/msg01634.html 
 > export GUIX_GTK2_IM_MODULE_FILE="$HOME/.guix-profile/lib/gtk-2.0/2.10.0/immodules-gtk2.cache" 
 > export GUIX_GTK3_IM_MODULE_FILE="$HOME/.guix-profile/lib/gtk-3.0/3.0.0/immodules-gtk3.cache" 
 > --8<---------------cut here---------------end--------------->8--- 
 >  
 > ご覧の通り、日本語入力はできています。 
 >  
 > If it still doesn't work for you, I'll be happy to help troubleshoot. 
 > I set this up years ago, and the one thing I remember is that it was a 
 > bit of a hassle. 

So, yeah, that didn't work for me. I added the exports to my "~/.bash_profile", rebooted, and still no "Japanese (Anthy)" listed anywhere.

Looking at ison's exports, I thought, "I 've seen this before", and yes, I found in my old notes about IBus that when you started IBus Preferences for the first time you were ask whether you wanted to start the ibus daemon, and on Yes, you were asked to export the following too:

    export GTK_IM_MODULE=ibus
    export XMODIFIERS=@im=ibus
    export QT_IM_MODULE=ibus

(For people reading this in the list archives, the second line is "export XMODIFIERS=ATim=ibus", where "AT" is the "at sign". The archives interpret it as an email address and won't display the line correctly).

The difference with ison's is that these exports use "ibus", not "xim". Ricardo mentions the three lines above in the previous discussion on the list too (https://lists.gnu.org/archive/html/help-guix/2016-04/msg00016.html). So I also tried this in my "~/.bash_profile":

    export GUIX_GTK2_IM_MODULE_FILE="$HOME/.guix-profile/lib/gtk-2.0/2.10.0/immodules-gtk2.cache" 
    export GUIX_GTK3_IM_MODULE_FILE="$HOME/.guix-profile/lib/gtk-3.0/3.0.0/immodules-gtk3.cache" 
    export IBUS_COMPONENT_PATH="$HOME/.guix-profile/share/ibus/component"
    export GTK_IM_MODULE=ibus
    export XMODIFIERS=@im=ibus
    export QT_IM_MODULE=ibus

And then rebooted. But nothing changed. I still can't find "Japanese (Anthy)" anywhere.

Working around this issue seems difficult, so I'll use romaji for now.

Thanks ison, Chris, and Florian for the help :)